<?php
use PHPUnit\Framework\TestCase;
use Infomaker\Everyware\Twig\EveryTwig;
use Infomaker\Everyware\Twig\FilesystemLoader;
use Twig\Environment;
/**
 * EveryTwigTest
 * @group EveryTwig
 */
class EveryTwigTest extends TestCase
{
    private $everyTwig;

    public function setUp()
    {
        parent::setUp();

        $this->everyTwig = EveryTwig::getInstance();
    }
    protected function tearDown()
    {
        $instance = EveryTwig::getInstance();
        $reflection = new ReflectionClass($instance);
        $instance = $reflection->getProperty('instance');
        $instance->setAccessible(true); // now we can modify that :)
        $instance->setValue(null, null); // instance is gone
        $instance->setAccessible(false); // clean up
    }

    /** @test */
    public function a_new_instance_can_be_created()
    {
        $this->assertInstanceOf(EveryTwig::class, EveryTwig::getInstance());
    }

    /** @test */
    public function it_can_be_initialized()
    {
        $loader = new FilesystemLoader();
        $twig = $this->everyTwig->init($loader);
        $this->assertInstanceOf(Environment::class, $twig);
    }
    
    /**
     * @test
     */
    public function it_throws_an_error_if_initialized_without_a_loader()
    {
        $this->expectException(ArgumentCountError::class);
        $twig = $this->everyTwig->init();
    }
}
